'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Picker = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _components = require('../components');

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _semanticUiReact = require('semantic-ui-react');

var _utils = require('../utils.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Picker = function (_React$Component) {
  _inherits(Picker, _React$Component);

  function Picker(props) {
    _classCallCheck(this, Picker);

    var _this = _possibleConstructorReturn(this, (Picker.__proto__ || Object.getPrototypeOf(Picker)).call(this, props));

    _this.setDatesRange = function (event, data) {
      var onDatesRangeChange = _this.props.onDatesRangeChange;

      _this.setState(function (_ref) {
        var datesRange = _ref.datesRange;

        var newState = void 0;
        if (datesRange.start && datesRange.end) {
          newState = {
            datesRange: { start: null, end: null }
          };
          onDatesRangeChange(event, (0, _utils.cloneReplaceValue)(data, _this.getDatesRange()));
        } else if (datesRange.start && datesRange.start.isAfter(data.value)) {
          newState = {
            datesRange: { start: null, end: null }
          };
          onDatesRangeChange(event, (0, _utils.cloneReplaceValue)(data, _this.getDatesRange()));
        } else if (datesRange.start) {
          newState = {
            datesRange: { start: datesRange.start, end: data.value }
          };
          onDatesRangeChange(event, (0, _utils.cloneReplaceValue)(data, _this.getDatesRange({
            start: datesRange.start,
            end: data.value
          })));
        } else {
          newState = {
            datesRange: { start: data.value, end: datesRange.end }
          };
          onDatesRangeChange(event, (0, _utils.cloneReplaceValue)(data, _this.getDatesRange({
            start: data.value,
            end: datesRange.end
          })));
        }
        return newState;
      });
    };

    _this.getDatesRange = function (range) {
      var _ref2 = range ? range : { start: null, end: null },
          start = _ref2.start,
          end = _ref2.end;

      var startStr = start && start.format ? start.format('DD.MM.YY') : '. . .';
      var endStr = end && end.format ? end.format('DD.MM.YY') : '. . .';
      return startStr + ' - ' + endStr;
    };

    _this.onDateClick = function (event, data) {
      var _this$props = _this.props,
          pickDatesRange = _this$props.pickDatesRange,
          onDateChange = _this$props.onDateChange;


      if (pickDatesRange) {
        _this.setDatesRange(event, data);
      } else {
        _this.setState({
          activeDate: data.value
        });
      }
      onDateChange(event, data);
    };

    _this.onHourClick = function (event, data) {
      _this.setState(function (prevState) {
        var newData = (0, _utils.cloneReplaceValue)(data, _this.getTime({
          hour: data.value,
          minute: ''
        }));
        _this.props.onTimeChange(event, newData);
        return {
          activeHour: data.value
        };
      });
    };

    _this.onMinuteClick = function (event, data) {
      _this.setState(function (prevState) {
        var newData = (0, _utils.cloneReplaceValue)(data, _this.getTime({
          hour: prevState.activeHour,
          minute: data.value
        }));
        _this.props.onTimeChange(event, newData);
        return {
          activeMinute: data.value
        };
      });
    };

    _this.getTime = function (_ref3) {
      var _ref3$hour = _ref3.hour,
          hour = _ref3$hour === undefined ? '' : _ref3$hour,
          _ref3$minute = _ref3.minute,
          minute = _ref3$minute === undefined ? '' : _ref3$minute;

      return hour + ':' + minute;
    };

    _this.onNextBtnClick = function (_ref4) {
      var day = _ref4.day;

      if (day) {
        _this.setState(function (_ref5) {
          var activeDate = _ref5.activeDate;

          var nextDay = activeDate.clone();
          nextDay.add(1, 'd');
          return { activeDate: nextDay };
        });
      } else {
        _this.setState(function (_ref6) {
          var showedMonth = _ref6.showedMonth;

          var nextMonth = showedMonth.clone();
          nextMonth.add(1, 'M');
          return { showedMonth: nextMonth };
        });
      }
    };

    _this.onPrevBtnClick = function (_ref7) {
      var day = _ref7.day;

      if (day) {
        _this.setState(function (_ref8) {
          var activeDate = _ref8.activeDate;

          var prevDay = activeDate.clone();
          prevDay.add(-1, 'd');
          return { activeDate: prevDay };
        });
      } else {
        _this.setState(function (_ref9) {
          var showedMonth = _ref9.showedMonth;

          var prevMonth = showedMonth.clone();
          prevMonth.add(-1, 'M');
          return { showedMonth: prevMonth };
        });
      }
    };

    _this.getActiveDate = function () {
      return _this.state.activeDate || (0, _moment2.default)();
    };

    _this.getDateTimePicker = function () {
      var _this$state = _this.state,
          activeDate = _this$state.activeDate,
          activeHour = _this$state.activeHour,
          activeMinute = _this$state.activeMinute,
          showedMonth = _this$state.showedMonth;

      var headerWidth = activeHour ? '3' : activeDate ? '4' : '7';
      if (!activeDate) {
        return _react2.default.createElement(
          _react2.default.Fragment,
          null,
          _react2.default.createElement(_components.DateTimePickerHeader, {
            onNextBtnClick: _this.onNextBtnClick,
            onPrevBtnClick: _this.onPrevBtnClick,
            showedDate: showedMonth,
            showDate: false,
            showWeeks: true,
            width: '7' }),
          _react2.default.createElement(_components.DatePickerComponent, {
            onDateClick: _this.onDateClick,
            activeDate: _this.getActiveDate(),
            showedMonth: showedMonth })
        );
      }
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        _react2.default.createElement(_components.DateTimePickerHeader, {
          onNextBtnClick: _this.onNextBtnClick.bind(null, { day: true }),
          onPrevBtnClick: _this.onPrevBtnClick.bind(null, { day: true }),
          showedDate: activeDate,
          showDate: true,
          showWeeks: false,
          width: headerWidth }),
        _react2.default.createElement(_components.TimePickerComponent, {
          activeHour: activeHour,
          activeMinute: activeMinute,
          onHourClick: _this.onHourClick,
          onMinuteClick: _this.onMinuteClick })
      );
    };

    _this.state = {
      activeDate: null,
      showedMonth: (0, _moment2.default)(),
      activeHour: '',
      datesRange: { start: null, end: null }
    };
    return _this;
  }

  _createClass(Picker, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          pickDate = _props.pickDate,
          pickTime = _props.pickTime,
          pickDateTime = _props.pickDateTime,
          pickDatesRange = _props.pickDatesRange;

      var rest = (0, _utils.getUnhandledProps)(Picker, this.props);

      if (pickDate) {
        return _react2.default.createElement(
          _semanticUiReact.Table,
          _extends({}, rest, {
            unstackable: true,
            celled: true,
            textAlign: 'center' }),
          _react2.default.createElement(_components.DateTimePickerHeader, {
            onNextBtnClick: this.onNextBtnClick,
            onPrevBtnClick: this.onPrevBtnClick,
            showedDate: this.state.showedMonth,
            showDate: false,
            showWeeks: true,
            width: '7' }),
          _react2.default.createElement(_components.DatePickerComponent, {
            onDateClick: this.onDateClick,
            activeDate: this.getActiveDate(),
            showedMonth: this.state.showedMonth })
        );
      }
      if (pickTime) {
        return _react2.default.createElement(
          _semanticUiReact.Table,
          _extends({}, rest, {
            unstackable: true,
            celled: true,
            textAlign: 'center' }),
          _react2.default.createElement(_components.TimePickerComponent, {
            activeHour: this.state.activeHour,
            activeMinute: this.state.activeMinute,
            onHourClick: this.onHourClick,
            onMinuteClick: this.onMinuteClick })
        );
      }
      if (pickDateTime) {
        return _react2.default.createElement(
          _semanticUiReact.Table,
          _extends({}, rest, {
            unstackable: true,
            celled: true,
            textAlign: 'center' }),
          this.getDateTimePicker()
        );
      }
      if (pickDatesRange) {
        return _react2.default.createElement(
          _semanticUiReact.Table,
          _extends({}, rest, {
            unstackable: true,
            celled: true,
            textAlign: 'center' }),
          _react2.default.createElement(_components.DateTimePickerHeader, {
            onNextBtnClick: this.onNextBtnClick,
            onPrevBtnClick: this.onPrevBtnClick,
            showedDate: this.state.showedMonth,
            showedRange: this.state.datesRange,
            showDate: false,
            showWeeks: true,
            width: '7' }),
          _react2.default.createElement(_components.DatePickerComponent, {
            datesRange: this.state.datesRange,
            onDateClick: this.onDateClick,
            showedMonth: this.state.showedMonth })
        );
      }
    }
  }]);

  return Picker;
}(_react2.default.Component);

Picker.handledProps = ['onDateChange', 'onDatesRangeChange', 'onTimeChange', 'pickDate', 'pickDateTime', 'pickDatesRange', 'pickTime'];


Picker.propTypes = {
  pickDate: _propTypes2.default.bool,
  pickTime: _propTypes2.default.bool,
  pickDateTime: _propTypes2.default.bool,
  pickDatesRange: _propTypes2.default.bool,
  /** (newDate) => {} 
   * @param {moment} newDate
  */
  onDateChange: _propTypes2.default.func,
  /** (newTime) => {}
   * @param {string} newTime hh:mm
   */
  onTimeChange: _propTypes2.default.func,
  /** (newDatesRange) => {}
   * @param {{start: moment, end: moment}} newDatesRange
  */
  onDatesRangeChange: _propTypes2.default.func
};

Picker.defaultProps = {
  onDateChange: function onDateChange() {},
  onTimeChange: function onTimeChange() {},
  onDatesRangeChange: function onDatesRangeChange() {}
};

exports.default = Picker;
exports.Picker = Picker;